
/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer: Patrick Boenzli
   co-programmer:
*/

#include "spawning_point.h"



/**
 *  standard constructor
 */
SpawningPoint::SpawningPoint (const Vector& absCoordinate, const World* world)
{}


/**
 *  constructor
 */
SpawningPoint::SpawningPoint (const Vector& position, float frequency,
                              float seed, int classID, const World* world)
  : WorldEntity(position)
{
  this->frequency = frequency;
  this->seed = seed;
  this->classID = classID;
  this->world = world;
}


/**
 *  deconstructor
 */
SpawningPoint::~SpawningPoint ()
{}


/**
 *  spawn the entity
 */
void SpawningPoint::spawn()
{
  PRINTF(5)("Spangingpoint creates a new Entity (id: %i, frequency: %f, seed: %f)\n", this->classID,
           this->frequency, this->seed);
  BaseObject* spawningEntity = Factory::fabricate(this->classID);
  if( LIKELY(this->world != NULL))
    this->world->spawn(dynamic_cast<WorldEntity*>(spawningEntity));
}



/**
 *  this method is called every frame
 * @param time: the time in seconds that has passed since the last tick
 *
 * Handle all stuff that should update with time inside this method (movement, animation, etc.)
 */
void SpawningPoint::tick(float dt)
{}


/**
 *  the entity is drawn onto the screen with this function
 *
 * This is a central function of an entity: call it to let the entity painted to the screen.
 * Just override this function with whatever you want to be drawn.
 */
void SpawningPoint::draw()
{}